package exnihilocreatio.client.renderers;

import exnihilocreatio.texturing.Color;
import exnihilocreatio.texturing.SpriteColor;
import exnihilocreatio.tiles.TileCrucibleBase;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import org.lwjgl.opengl.GL11;

public class RenderCrucible extends TileEntitySpecialRenderer<TileCrucibleBase> {
    @Override
    public void func_192841_a(TileCrucibleBase te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        Tessellator tes = Tessellator.func_178181_a();
        BufferBuilder wr = tes.func_178180_c();


        RenderHelper.func_74518_a();
        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x, y, z);
        SpriteColor[] sprite = te.getSpriteAndColor();

        if (sprite != null && (sprite[0] != null || sprite[1] != null)) {
            this.func_147499_a(TextureMap.field_110575_b);

            wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181712_l);
            // Makes the fluid have the correct transparency
            GlStateManager.func_179147_l();
            GlStateManager.func_179112_b(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);

            addSpriteColor(te, sprite[0], wr, false);
            addSpriteColor(te, sprite[1], wr, true);

            tes.func_78381_a();
        }

        GlStateManager.func_179084_k();
        GlStateManager.func_179145_e();
        GlStateManager.func_179121_F();
        RenderHelper.func_74519_b();

    }

    public void addSpriteColor(TileCrucibleBase te, SpriteColor sprite, BufferBuilder wr, boolean isFluid) {
        if (sprite != null) {
            TextureAtlasSprite icon = sprite.getSprite();
            double minU = (double) icon.func_94209_e();
            double maxU = (double) icon.func_94212_f();
            double minV = (double) icon.func_94206_g();
            double maxV = (double) icon.func_94210_h();

            // determine the tint for the fluid/block
            Color color = sprite.getColor();


            //wr.begin(GL11.GL_QUADS, new VertexFormat().addElement(DefaultVertexFormats.POSITION_3F).addElement(DefaultVertexFormats.COLOR_4UB).addElement(DefaultVertexFormats.NORMAL_3B));
            // Offset by bottome of crucibleStone, which is 4 pixels above the base of the block (and make it stop on pixel below the top)
            float fillAmount;
            if (isFluid) {
                fillAmount = ((12F / 16F) * te.getFluidProportion() + (4F / 16F)) * 0.9375F;
            } else {
                fillAmount = ((12F / 16F) * te.getSolidProportion() + (4F / 16F)) * 0.9375F;
            }

            wr.func_181662_b(0.0625F, fillAmount, 0.0625F).func_187315_a(minU, minV).func_181666_a(color.r, color.g, color.b, color.a).func_181663_c(0, 1, 0).func_181675_d();
            wr.func_181662_b(0.0625F, fillAmount, 0.9375F).func_187315_a(minU, maxV).func_181666_a(color.r, color.g, color.b, color.a).func_181663_c(0, 1, 0).func_181675_d();
            wr.func_181662_b(0.9375F, fillAmount, 0.9375F).func_187315_a(maxU, maxV).func_181666_a(color.r, color.g, color.b, color.a).func_181663_c(0, 1, 0).func_181675_d();
            wr.func_181662_b(0.9375F, fillAmount, 0.0625F).func_187315_a(maxU, minV).func_181666_a(color.r, color.g, color.b, color.a).func_181663_c(0, 1, 0).func_181675_d();
        }
    }

}
